<?php 
/*
Plugin Name: Tagline Randomizer
Plugin URI: http://dailydoseofdave.net/tagline-randomizer
Description: Tagline Randomizer does just as it says.  It changes the tagline that appears on your site from a user defined list.
Version: 0.99b
Author: David P Brown
Author URI: http://dailydoseofdave.net
*/

// This function merely adds the Tagline Randomizer subpanel to the Options menu
function tr_add_options_page() 
	{
		if (function_exists('add_options_page')) 
			{
			add_options_page('Tagline Randomizer', 'Tagline Randomizer', 5, basename(__FILE__), 'tr_options_subpanel');
			}
	}

// Function updates the tagline value in the database with a random tagline.  It is run at the 'init' Activity Hook.
function tr_execute()
{
	$handle = @fopen("tr_taglines.txt", "r");
	if ($handle) 
	{
		$x = 1;
		while (!feof($handle)) 
		{
			$buffer[$x] = fgets($handle);
			if ( ! strlen(trim($buffer[$x])) == 0)
			{
				$x++;
			}
		}
		fclose($handle);
		update_option('blogdescription', $buffer[rand(1,$x)]);
	}
}

// Function is called anytime the tagline value is to be changed in the database.
function tr_update_file($tr_contents)
{
	$your_data = $tr_contents;
	// Open the file and erase the contents if any
	$fp = fopen("tr_taglines.txt", "w");
	// Write the data to the file
	fwrite($fp, $your_data);
	// Close the file
	fclose($fp);

}


// Function is called to read possible tagline values from external text file.
function tr_read_file()
{
	// get contents of a file into a string
	$filename = "tr_taglines.txt";
	$handle = fopen($filename, "r");
	if ( filesize($filename) == 0 )
	{
		$contents = "";
	} else {
		$contents = fread($handle, filesize($filename));
	}
	fclose($handle);
	return $contents;
}
 
// Function contains menu and instruction information for the Tagline Randomizer subpanel on the Options menu
function tr_options_subpanel() {
  if (isset($_POST['info_update'])) {
    ?><div class="updated"><p><strong><?php 

	tr_update_file(trim(stripslashes($_POST['tr_contents'])));
	_e('Taglines updated');

    ?></strong></p></div><?php
	} ?>
<div class=wrap>
  <form method="post">
    <h2>Tagline Randomizer</h2>
     <fieldset name="set1">
	<legend><?php _e('Enter each tagline on a separate line.', 'Localization name') ?></legend>

<textarea name="tr_contents" rows=20 cols=75>
<?php echo tr_read_file(); ?>
</textarea>

     </fieldset>
<div class="submit">
  <input type="submit" name="info_update" value="<?php _e('Update options &raquo;', 'Localization name') ?> " /></div>
  </form>
 </div><?php
}

// Function is run when plugin is activated.
function tr_setup()
{
	$tr_filename= "tr_taglines.txt";
	if ( ! file_exists($tr_filename) ) 
		{
		tr_update_file(get_option('blogdescription'));
		}
}

// Installation/Initialization Routine
if (isset($_GET['activate']) && $_GET['activate'] == 'true')
	{
	add_action('init', 'tr_setup');
	}

add_action('init', 'tr_execute');
add_action('admin_menu', 'tr_add_options_page');

?>